var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var fetch_jwks_exports = {};
__export(fetch_jwks_exports, {
  default: () => fetch_jwks_default
});
var http = __toESM(require("http"));
var https = __toESM(require("https"));
var import_events = require("events");
var import_errors = require("../util/errors.js");
var import_buffer_utils = require("../lib/buffer_utils.js");
const fetchJwks = async (url, timeout, options) => {
  let get;
  switch (url.protocol) {
    case "https:":
      get = https.get;
      break;
    case "http:":
      get = http.get;
      break;
    default:
      throw new TypeError("Unsupported URL protocol.");
  }
  const { agent } = options;
  const req = get(url.href, {
    agent,
    timeout
  });
  const [response] = await Promise.race([(0, import_events.once)(req, "response"), (0, import_events.once)(req, "timeout")]);
  if (!response) {
    req.destroy();
    throw new import_errors.JWKSTimeout();
  }
  if (response.statusCode !== 200) {
    throw new import_errors.JOSEError("Expected 200 OK from the JSON Web Key Set HTTP response");
  }
  const parts = [];
  for await (const part of response) {
    parts.push(part);
  }
  try {
    return JSON.parse(import_buffer_utils.decoder.decode((0, import_buffer_utils.concat)(...parts)));
  } catch {
    throw new import_errors.JOSEError("Failed to parse the JSON Web Key Set HTTP response as JSON");
  }
};
var fetch_jwks_default = fetchJwks;
module.exports = __toCommonJS(fetch_jwks_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
