var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var sign_exports = {};
__export(sign_exports, {
  default: () => sign_default
});
var crypto = __toESM(require("crypto"));
var import_util = require("util");
var import_dsa_digest = __toESM(require("./dsa_digest.js"));
var import_hmac_digest = __toESM(require("./hmac_digest.js"));
var import_node_key = __toESM(require("./node_key.js"));
var import_get_sign_verify_key = __toESM(require("./get_sign_verify_key.js"));
let oneShotSign;
if (crypto.sign.length > 3) {
  oneShotSign = (0, import_util.promisify)(crypto.sign);
} else {
  oneShotSign = crypto.sign;
}
const sign = async (alg, key, data) => {
  const keyObject = (0, import_get_sign_verify_key.default)(alg, key, "sign");
  if (alg.startsWith("HS")) {
    const hmac = crypto.createHmac((0, import_hmac_digest.default)(alg), keyObject);
    hmac.update(data);
    return hmac.digest();
  }
  return oneShotSign((0, import_dsa_digest.default)(alg), data, (0, import_node_key.default)(alg, keyObject));
};
var sign_default = sign;
module.exports = __toCommonJS(sign_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
